
local CO = require "api_coservice"
local MSG = require "api_msg"
local cjson = require "cjson"

local dset = {}
------------------------------------------------ 前置裁切

local function API_set(red,args)
    if not args or not args.sourceId then
        MSG.ERROR( "argumentError" )
        return true
    end

    local proxy = CO.GetProxy( "/avio", "codec", args.sourceId )
    if not proxy then
        MSG.ERROR( "codecError" )
        return true
    else
        local tabs={}
        tabs.enable = args.enable
        tabs.left = args.left
        tabs.top = args.top
        tabs.width = args.width
        tabs.height = args.height
        tabs.format = args.format
        tabs.Rmf = args.Rmf

        local r,done,err = proxy.SetSourceCropConfig(tabs)
        proxy:Destroy()

        if not r or not done then
            MSG.ERROR( "setLocalCropError" )
        else
            MSG.OK()
        end
    end
    return true
end

local function API_get(red, args)
	if not args or not args.sourceId then
		MSG.ERROR( "argumentError" )
        return true
	end
    local proxy = CO.GetProxy( "/avio", "codec", args.sourceId )
    if not proxy then
        MSG.ERROR( "codecError" )
        return true
    else
        local r,data,err = proxy.GetSourceCropConfig()
        proxy:Destroy()

        if not r or not data then
            MSG.ERROR( "getLocalCropError" )
        else
            MSG.OK("",{data=data})
        end
    end
    return true
end

----------------------
dset.APIS = dset.APIS or {}

dset.APIS["get"] = API_get
dset.APIS["modify"] = API_set

--------------------------------------
return dset

