local CO = require "api_coservice"
local MSG = require "api_msg"

local dset = {}
--------------------------------------
local function API_set(_, args)
    if not args or not args.policy or not args.date or not args.n_hour then
		MSG.ERROR( "argumentError" )
		return true
	end

	local proxy = CO.GetProxy( "/sysctrlTimer", "systemctrl" )
	if not proxy then
		MSG.ERROR( "systemError" )
	else
		local r,done = proxy.SetTimerInfo(args, nil)
		proxy:Destroy()
		if r and done then
			MSG.OK()
		else
			MSG.ERROR("setSysTimerInfoError")
		end
	end
	return true
end

local function API_get(_, args)
	if args then
		local proxy = CO.GetProxy( "/sysctrlTimer", "systemctrl" )
		if not proxy then
			MSG.ERROR( "systemError" )
		else
			local r,done = proxy.GetTimerInfo()
			proxy:Destroy()
			if r and done then
				MSG.OK("", {
					data = done
				})
			else
				MSG.ERROR("getSysTimerInfoError")
			end
		end
	else
		MSG.ERROR( "argumentError" )
	end
	return true
end

--------------------------------------
dset.APIS = dset.APIS or {}

dset.APIS["get"] = API_get
dset.APIS["set"] = API_set

--------------------------------------
return dset

