local CFG = require "supertable.core"
local DC = require "supertable.declare"

local _M = {
	config_file = "/data/configs/CoManager.conf"
}


local general_set_decl = DC.OBJ {
        link_token= DC.STR(),
        link_name= DC.STR(),
        devices= DC.SET( DC.OBJ {
                id= DC.STR(),
                name= DC.STR(),
				address= DC.STR(),
				web_port= DC.STR(),
				username= DC.STR(),
				password= DC.STR(),
				port= DC.STR(),
				department = DC.SET( DC.OBJ {
					id=DC.STR(),
					departmentName= DC.STR(),
				}),
                link_token= DC.STR()
        } )
          
}: __changed( function(conf)
        conf:TAB_SAVE()
end )

local failDefault={
        link_token = "123456789",
        link_name = "MS2",
        devices={
                ["1"] = {
                        id="1",
                        name="平台",
                        address= "192.168.0.1",
						port= "14000",
						web_port= "9000",
                        link_token="123456789",
						status="dead",
						username="",
						password="",
						department={},
                        manual=true
                },
        }
}

function _M.Load(file)
        local gen_set = CFG.Create( {}, general_set_decl )
        gen_set:TAB_STORAGE( "file", { file = _M.config_file } )
        local _, r = gen_set:TAB_LOAD()
        if not r then
            gen_set:TAB_BIND( failDefault )
        end
        gen_set:TAB_RESET_CHANGE()
        return gen_set
end

return _M
