local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/ain.conf"
}

local ain_template = DC.OBJ({
	source = DC.STR("LINEIN"),
	gain = DC.NUM(0)
})
: __changed( function(conf)
	conf:TAB_SAVE()
end)

--------------------------------------------


function _M.Load()
	local conf = CONF.Create({}, ain_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
	local _, r = conf:TAB_LOAD()
	--if not r then --Try load a fail-default configure
	--	conf:TAB_BIND(fail_default or {})
	--end
	conf:TAB_RESET_CHANGE()
	return conf
end

-------------------------------------------------------
return _M
