--[[
Description:
Author:
Date: 2021-03-04 08:07:59
LastEditTime: 2021-03-08 09:15:12
LastEditors: Please set LastEditors
--]]
local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/audio_mix.conf"
}

--------------------------------------------------------
local audio_mix_template = DC.SET(
    DC.OBJ{
        volume = DC.INT(142),
        mute = DC.INT(0),
        zero = DC.INT(120),
    }
) : __changed( function(conf)
	conf:TAB_SAVE()
end)

--测试发现声音较小,故此处默认值全部设置142(对应界面的'0'), channel需要存储DB值
local temp = {
    usb_channel = {mute = 0, volume = 142, zero = 120},
    channel = {mute = 0, volume = 0, zero = 120},
    vs0_channel = {mute = 0, volume = 142, zero = 120},
    vs1_channel = {mute = 0, volume = 142, zero = 120},
}

-------------------------------------------------------

function _M.Load()
	local conf = CONF.Create({}, audio_mix_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
    local _, r = conf:TAB_LOAD()
    if not r then --Try load a fail-default configure
        conf:TAB_BIND(temp or {})
        conf:TAB_SAVE()
	end
	conf:TAB_RESET_CHANGE()
	return conf
end

-------------------------------------------------------

return _M