local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/audio_stream_out.conf"
}

--------------------------------------------------------
local audio_stream_out = DC.OBJ({
    hd0 = DC.SET(
        DC.OBJ{
            volume = DC.INT(142),
            mute = DC.INT(0),
            zero = DC.INT(120),
        }
    ),

    hd1 = DC.SET(
        DC.OBJ{
            volume = DC.INT(142),
            mute = DC.INT(0),
            zero = DC.INT(120),
        }
    ),
}) : __changed( function(conf)
	conf:TAB_SAVE()
end)

local temp = {
    ["hd0"] = {}, ["hd1"] = {}
}

-------------------------------------------------------

function _M.Load()
	local conf = CONF.Create({}, audio_stream_out)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
    local _, r = conf:TAB_LOAD()
    if not r then --Try load a fail-default configure
        conf:TAB_BIND(temp or {})
	end
	conf:TAB_RESET_CHANGE()
	return conf
end

-------------------------------------------------------

return _M