local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/record_setting.conf"
}

--------------------------------------------------------
local record_setting_template = DC.OBJ({
	double_backup = DC.INT(1),
	disk = DC.INT(1),
	format = DC.STR("mp4"),
	limitation = DC.STR("time_loop"),
	limitSize = DC.INT(1024),
	limitTime = DC.STR("60"),
	disk_policy = DC.STR("alternate")
}) : __changed( function(conf)
	conf:TAB_SAVE()
end)

-------------------------------------------------------

function _M.Load()
	local conf = CONF.Create({}, record_setting_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
	conf:TAB_LOAD()
	conf:TAB_RESET_CHANGE()
	return conf
end

-------------------------------------------------------

return _M