local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/sip.conf"
}

--------------------------------------------

local sip_template = DC.OBJ{
	binds = DC.STR("*:5060"),
	accounts = DC.SET(
		DC.OBJ{
			name = DC.STR(""),
			protocol = DC.STR("sip"),
			realm = DC.STR("*"),
			localAccount = DC.STR(""),
			localAddress = DC.STR(""),
			registerServer = DC.STR(""),
			registerPort = DC.INT(5060),
			serverId = DC.STR(""),
			username = DC.STR(""),
			password = DC.STR(""),
			
			source_id = DC.STR(""),
			buffer_option = DC.STR("live:200:200:500:0:0"),

			gb28181_options = DC.OBJ{
			},

			call_in_options = DC.OBJ{
				allow = DC.BOOL(true),
				policy = DC.INT(1),
				auto_answer = DC.BOOL(false)
			},

			call_out_options = DC.OBJ{
				target = DC.STR(""),
				auto_call = DC.BOOL(false),
				create_stream = DC.BOOL(true)
			}
		}
	)
} : __changed( function(conf)
	conf:TAB_SAVE()
end)

--------------------------------------------

function _M.Load()
	local conf = CONF.Create({}, sip_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
	conf:TAB_LOAD()
	conf:TAB_RESET_CHANGE()
	return conf
end

-------------------------------------------------------

return _M

