local sys_config = require "sys_config"

local _M = {
	decoderGroups = {},
	decoderGroupsUsing = {},
	using_channels = {}
}

function _M.Init()
	local i
	for i=1, sys_config.CREATE_DECODER_GROUPS do
		_M.decoderGroups[i] = KM_STREAMING.HISI.Decoder.createNew( "DECODER-GROUP-" .. i )
		_M.decoderGroupsUsing[i] = 0
	end
end

function _M.AllocateDecoderGroup()
	local i, min, min_group
	for i=1, sys_config.CREATE_DECODER_GROUPS do
		if not min or _M.decoderGroupsUsing[i] < min then
			min = _M.decoderGroupsUsing[i]
			min_group = i
		end
	end

	_M.decoderGroupsUsing[min_group] = _M.decoderGroupsUsing[min_group] + 1
	return min_group, _M.decoderGroups[min_group]
end

function _M.FreeDecoderGroup(id)
	if _M.decoderGroupsUsing[ id ] and _M.decoderGroupsUsing[ id ] > 0 then
		_M.decoderGroupsUsing[ id ] = _M.decoderGroupsUsing[ id ] - 1
	end
end

function _M.AllocateDecoderChannel()
	local i
	for i=sys_config.DECODER_CHANNEL_START, sys_config.DECODER_CHANNEL_START + sys_config.MAX_DECODER_CHANNELS - 1 do
		if not _M.using_channels[i] then
			_M.using_channels[i] = true
			return i
		end
	end
	return nil
end

function _M.FreeDecoderChannel(channel)
	if channel then
		_M.using_channels[channel] = nil
	end
end

return _M

