local mo_Oled = require "mod_Oled"
local mo_OPage = require "mod_OledPage"
local mo_Pages = require "mod_Pages"
local mo_Icon = require "mod_IconData"

local _M={
}

local pagemeta = {}

function pagemeta:DrawPage()
    self:Drawicon()
end

function pagemeta:Pageup()  
    if self.selectindex == #(self.icons) then
        return
    end

    self.selectindex = self.selectindex + 1
    self:Drawicon()
end

function pagemeta:Pagedown()    
    if self.selectindex == 1 then
        return
    end

    self.selectindex = self.selectindex - 1
    self:Drawicon()
end

function pagemeta:Getpages()
    return self.icons[self.selectindex].subpages
end

function pagemeta:Getindex()
    return self.windowindex,self.selectindex
end

function pagemeta:Drawicon()
    local i,negative,index
    local x = 8
    local y=4
    if self.selectindex >= self.windowindex + self.windowmaxicon then
        self.windowindex =  self.selectindex - self.windowmaxicon + 1
    end
    if self.selectindex < self.windowindex then
        self.windowindex =  self.selectindex
    end
    index = self.windowindex

    -- Display name
    mo_Oled.OLED_ClearLine(0)
    mo_Oled.OLED_ClearLine(1)
    mo_Oled.OLED_ClearLine(2)
    if type(self.icons[self.selectindex].title) == "table" then
        if self.icons[self.selectindex].title[3] then --3个字title
            mo_Oled.OLED_DrawBMP(40,1,16,16,self.icons[self.selectindex].title[1])
            mo_Oled.OLED_DrawBMP(56,1,16,16,self.icons[self.selectindex].title[2])
            mo_Oled.OLED_DrawBMP(72,1,16,16,self.icons[self.selectindex].title[3])
        else
            mo_Oled.OLED_DrawBMP(42,1,16,16,self.icons[self.selectindex].title[1])
            mo_Oled.OLED_DrawBMP(70,1,16,16,self.icons[self.selectindex].title[2])
        end
    elseif type(self.icons[self.selectindex].title) == "string" then
        local strlen = #(self.icons[self.selectindex].title)
        local x_pos = math.floor((128 - 8 * strlen) / 2)
        -- print(x_pos)
        mo_Oled.OLED_ShowHanz(x_pos,1,self.icons[self.selectindex].title,16)
    end

    if ( self.windowindex > 1) then
        mo_Oled.OLED_DrawBMP(0,3,4,32,mo_Icon.lefttriangle.data)
    else
        mo_Oled.OLED_DrawBMP(0,3,4,32,mo_Icon.blanktriangle.data)
    end

    -- Display Icons
    for i=1, self.windowmaxicon do
        tmpstr = ""
        if self.selectindex == index then
            negative = true
        else
            negative = false
        end
        mo_Oled.OLED_DrawBMP(x,y,32,32,self.icons[index].data,negative)
               
        x = x + 8 + 32 
        index = index +1
        -- if index > #icons then
        --     index = 1
        -- end
    end

    if ( self.windowindex + self.windowmaxicon - 1 < #(self.icons) ) then
        mo_Oled.OLED_DrawBMP(124,3,4,32,mo_Icon.righttriangle.data)
    else
        mo_Oled.OLED_DrawBMP(124,3,4,32,mo_Icon.blanktriangle.data)
    end
    
end



pagemeta.__index = pagemeta

function _M.init()
end

function _M.createNew(icons,windowindex,selectindex)
    if not windowindex then 
        windowindex = 1
    end
    if not selectindex then 
        selectindex = 1
    end
    local pageObj = {
        windowmaxicon = 3, --窗口最大显示图标数量
        windowindex = windowindex,   --窗口起始显示图标index
        selectindex = selectindex,   --当前选中index
        icons = icons,
        type = "iconpage",
        oppage = false
    }    

    setmetatable( pageObj, pagemeta )
    return pageObj
end
    
-- drawicon()
-- selectindex = 2
-- drawicon()



-- selectindex = 1
-- drawicon()

-- local pagenow = mo_OPage.createNew(icons[selectindex].pagedata)	
-- pagenow:DrawPage()

return _M