local mo_Oled = require "mod_Oled"
local _dbg = require "coaf.debug"
local pt = require "pl.pretty"


local _M ={ 
        
}

local pagemeta = {}

function pagemeta:DrawBackGround()
    if self.bg then
        mo_Oled.OLED_FillPicture(self.bg)
    else
        _dbg.Error("OledPage", "bg is nil!")	
    end
end

function pagemeta:DrawText()  
    if self.texts then 
        for i= 1, #self.texts do
            if (self.texts[i].str) then
                mo_Oled.OLED_ShowHanz(self.texts[i].x,self.texts[i].y,self.texts[i].str,self.texts[i].size)
            else
                _dbg.Error("OledPage", "str is nil!")	
            end
		end
	end
end

function pagemeta:DrawIcon()
    if self.icons then 
		for i= 1, #self.icons do
			mo_Oled.OLED_DrawBMP(self.icons[i].x,self.icons[i].y,self.icons[i].icon.width,self.icons[i].icon.height,self.icons[i].icon.data)
		end
	end	
end

function pagemeta:DrawPage()  
    self:DrawBackGround()
    self:DrawIcon()    
    self:DrawText()
end

function pagemeta:Update(page)
    _dbg.Error("OledPage", "Update")	
    self = _M.createNew(page)
end


pagemeta.__index = pagemeta

--============================================
function _M.createNew(page)    
    local pageObj = {}

    if page.bg then
        pageObj.bg = page.bg
    end

    if page.texts then
        pageObj.texts = page.texts
    end

    if page.icons then
        pageObj.icons = page.icons
    end

    if page.getinfo then
        pageObj.getinfo = page.getinfo
    end

    if page.f1 then
        pageObj.f1 = page.f1
    end

    if page.f2 then
        pageObj.f2 = page.f2
    end

    if page.f3 then
        pageObj.f3 = page.f3
    end

    if page.f4 then
        pageObj.f4 = page.f4
    end

    --是否操作页面
    if page.oppage then
        pageObj.oppage = page.oppage
    else
        pageObj.oppage = false
    end

    -- if page.diskid then
    --     _dbg.Error("OledPage", "diskid="..page.diskid)	
    --     pageObj.diskid = page.diskid
    -- end

    if (pageObj.getinfo) and (type(pageObj.getinfo) == "function") then
        pageObj:getinfo(pageObj)
    end

    -- pt.dump(pageObj)

    setmetatable( pageObj, pagemeta )
    return pageObj
end
--============================================

return _M