local _dbg = require "coaf.debug"
local mo_bg = require "mod_BgData"
local mo_icon = require "mod_IconData"
local mo_info = require "mod_GetInfo"
local mo_OPage = require "mod_OledPage"
local mo_Hanz = require "mod_HanzIcon"

local pt = require "pl.tablex"
local pl = require "pl.pretty"


local _M ={ 
           
}


_M.LOGO = {
    bg = mo_bg.LOGO
}

_M.VIDEOIN1 = {
    bg = mo_bg.videoin1,
    getinfo =  function (page)        
        local info = mo_info.getVideoInInfo()
        if info then            
            -- page.texts[2].str = info['1'].format
            -- page.texts[4].str = info['2'].format
            if(info['1'].signal) then
                page.icons[1].icon = mo_icon.ok
                page.texts[2].str = info['1'].format
            else
                page.icons[1].icon = mo_icon.error
                page.texts[2].str = "UNKNOWN"
            end
            if(info['2'].signal) then
                page.icons[2].icon = mo_icon.ok
                page.texts[4].str = info['2'].format
            else
                page.icons[2].icon = mo_icon.error
                page.texts[4].str = "UNKNOWN"
            end
        end        
    end,
    texts = {
        {
            x = 2,
            y = 1,
            str = 'HDMI',
            size = 8
        },
        {
            x = 2,
            y = 2,
            str = '----',
            size = 8
        },
        {
            x = 2,
            y = 5,
            str = 'SDI-1',
            size = 8
        },
        {
            x = 2,
            y = 6,
            str = '----',
            size = 8
        }
    },
    icons = {
        {
            x = 113,
            y = 1,
            icon = mo_icon.error
        },
        {
            x = 113,
            y = 5,
            icon = mo_icon.error
        }
    }
}

_M.VIDEOIN2 = {
    bg = mo_bg.videoin1,
    getinfo =  function (page)  
        local info = mo_info.getVideoInInfo()
        if info then
            if(not info['3']) then
                page.texts[1].str = "NONE"
                page.texts[2].str = "----"
            else
                if( info['3'] and info['3'].signal) then
                    page.icons[1].icon = mo_icon.ok
                    page.texts[2].str = info['3'] and info['3'].format or "UNKNOWN"
                else
                    page.icons[1].icon = mo_icon.error
                    page.texts[2].str = "UNKNOWN"
                end
            end
            if(not info['4']) then
                page.texts[3].str = "NONE"
                page.texts[4].str = "----"
            else
                if(info['4'] and info['4'].signal) then
                    page.icons[2].icon = mo_icon.ok
                    page.texts[4].str = info['4'] and info['4'].format or "----"
                else
                    page.icons[2].icon = mo_icon.error
                    page.texts[4].str = "UNKNOWN"
                end
            end
        end    
    end,
    texts = {
        {
            x = 2,
            y = 1,
            str = 'SDI-2',
            size = 8
        },
        {
            x = 2,
            y = 2,
            str = '----',
            size = 8
        },
        {
            x = 2,
            y = 5,
            str = 'SDI-3',
            size = 8
        },
        {
            x = 2,
            y = 6,
            str = '----',
            size = 8
        }
    },
    icons = {
        {
            x = 113,
            y = 1,
            icon = mo_icon.error
        },
        {
            x = 113,
            y = 5,
            icon = mo_icon.error
        }
    }
}

_M.NETWORK = {
    -- bg = mo_bg.p3,
    bg = mo_bg.network,
    getinfo =  function (page)
        local netinfo = mo_info.getEthInfo()
        if (netinfo) then
            if (netinfo.eth0_status=="up") then
                page.icons[1].icon = mo_icon.ok
            end
            if (netinfo.eth1_status=="up") then
                page.icons[2].icon = mo_icon.ok
            end

            if (netinfo.eth0_ip) then
                page.texts[1].str = netinfo.eth0_ip
            end

            if (netinfo.eth1_ip) then
                page.texts[2].str = netinfo.eth1_ip
            end
        end
    end,
    texts = {
        {
            x = 25,
            y = 2,
            str = "-.-.-.-",
            size = 8
        },
        {
            x = 25,
            y = 5,
            str = "-.-.-.-",
            size = 8
        }
    },
    icons = {
        {
            x = 113,
            y = 1,
            icon = mo_icon.error
        },
        {
            x = 113,
            y = 4,
            icon = mo_icon.error
        },
        {
            x = 75,
            y = 6,
            icon = mo_icon.reset
        },
        {
            x = 110,
            y = 6,
            icon = mo_icon.back
        }
    }        
}

_M.ENCODER = {
    bg = mo_bg.encoder
}

_M.ENCODER1 = {
    bg = mo_bg.encoderstat,
    getinfo =  function (page)        
        local encoderinfo = mo_info.getEncoderInfo(1)
        page.texts[2].str = encoderinfo.bitrate
        page.texts[3].str = encoderinfo.resolution
        page.texts[4].str = encoderinfo.codec
    end,
    texts = {
        {
            x = 45,
            y = 0,
            str = "HDMI",
            size = 8
        },
        {
            x = 28,
            y = 2,
            str = "--KBps",
            size = 8
        },
        {
            x = 28,
            y = 4,
            str = "----",
            size = 8
        },
        {
            x = 28,
            y = 6,
            str = "OFF",
            size = 8
        }
    }
}
_M.ENCODER2 = {
    bg = mo_bg.encoderstat,
    getinfo =  function (page)        
        local encoderinfo = mo_info.getEncoderInfo(2)
        page.texts[2].str = encoderinfo.bitrate
        page.texts[3].str = encoderinfo.resolution
        page.texts[4].str = encoderinfo.codec
    end,
    texts = {
        {
            x = 45,
            y = 0,
            str = "SDI-1",
            size = 8
        },
        {
            x = 28,
            y = 2,
            str = "--KBps",
            size = 8
        },
        {
            x = 28,
            y = 4,
            str = "----",
            size = 8
        },
        {
            x = 28,
            y = 6,
            str = "OFF",
            size = 8
        }
    }
}

_M.ENCODER3 ={
    bg = mo_bg.encoderstat,
    getinfo =  function (page)        
        local encoderinfo = mo_info.getEncoderInfo(3)
        page.texts[2].str = encoderinfo.bitrate
        page.texts[3].str = encoderinfo.resolution
        page.texts[4].str = encoderinfo.codec
    end,
    texts = {
        {
            x = 45,
            y = 0,
            str = "SDI-2",
            size = 8
        },
        {
            x = 28,
            y = 2,
            str = "--KBps",
            size = 8
        },
        {
            x = 28,
            y = 4,
            str = "----",
            size = 8
        },
        {
            x = 28,
            y = 6,
            str = "OFF",
            size = 8
        }
    }
}        

_M.ENCODER4 ={
    bg = mo_bg.encoderstat,
    getinfo =  function (page)        
        local encoderinfo = mo_info.getEncoderInfo(4)
        page.texts[2].str = encoderinfo.bitrate
        page.texts[3].str = encoderinfo.resolution
        page.texts[4].str = encoderinfo.codec
    end,
    texts = {
        {
            x = 45,
            y = 0,
            str = "SDI-3",
            size = 8
        },
        {
            x = 28,
            y = 2,
            str = "--KBps",
            size = 8
        },
        {
            x = 28,
            y = 4,
            str = "----",
            size = 8
        },
        {
            x = 28,
            y = 6,
            str = "OFF",
            size = 8
        }
    }
}  

_M.ENCODER5 ={
    bg = mo_bg.encoderstat,
    getinfo =  function (page)        
        local encoderinfo = mo_info.getOutputEncoderInfo(1)
        page.texts[2].str = encoderinfo.bitrate
        page.texts[3].str = encoderinfo.resolution
        page.texts[4].str = encoderinfo.codec
    end,
    texts = {
        {
            x = 38,
            y = 0,
            str = "OUTPUT1",
            size = 8
        },
        {
            x = 28,
            y = 2,
            str = "--KBps",
            size = 8
        },
        {
            x = 28,
            y = 4,
            str = "----",
            size = 8
        },
        {
            x = 28,
            y = 6,
            str = "OFF",
            size = 8
        }
    }
}  

_M.ENCODER6 = {
    bg = mo_bg.encoderstat,
    getinfo =  function (page)        
        local encoderinfo = mo_info.getOutputEncoderInfo(2)
        page.texts[2].str = encoderinfo.bitrate
        page.texts[3].str = encoderinfo.resolution
        page.texts[4].str = encoderinfo.codec
    end,
    texts = {
        {
            x = 38,
            y = 0,
            str = "OUTPUT2",
            size = 8
        },
        {
            x = 28,
            y = 2,
            str = "--KBps",
            size = 8
        },
        {
            x = 28,
            y = 4,
            str = "----",
            size = 8
        },
        {
            x = 28,
            y = 6,
            str = "OFF",
            size = 8
        }
    }
}  

_M.PLATFORM = {
    bg= mo_bg.platform,
    getinfo =  function (page)        
        local platforminfo = mo_info.getPlatform()
        if platforminfo then
            page.texts[1].str = platforminfo.address..":"..platforminfo.port

            if platforminfo.status then
                page.icons[1].icon = mo_icon.ok
            else
                page.icons[1].icon = mo_icon.error    
            end
        end        
    end,
    texts = {
        {
            x = 4,
            y = 5,
            str = "----",
            size = 8
        },
        {
            x = 40,
            y = 1,
            str = "PLATFORM",
            size = 16
        }
    },
    icons = {
        {
            x = 113,
            y = 1,
            icon = mo_icon.error
        }
    }
}

_M.HARDDISK1 = {
    bg = mo_bg.diskinfo, 
    getinfo =  function (page)
        local diskinfo = mo_info.getSATA(1)
        if (diskinfo) then
            if (diskinfo.stat == 0) then
                -- page.icons[1].icon = mo_icon.disk0
                page.texts[3].str = "NO DISK   "
            end

            if (diskinfo.stat == 1) then
                -- page.icons[1].icon = mo_icon.disk1
                page.texts[3].str = "NO RECORDING"
            end

            if (diskinfo.stat == 2) then
                -- page.icons[1].icon = mo_icon.disk2
                page.texts[3].str = "NOT MOUNT  "
            end

            if (diskinfo.stat == 3) then
                -- page.icons[1].icon = mo_icon.disk3
                page.texts[3].str = "RECORDING "
            end


            if (diskinfo.stat == 4) then
                -- page.icons[1].icon = mo_icon.disk4
                page.texts[3].str = "ERROR   "
            end


            if (diskinfo.stat == 5) then
                -- page.icons[1].icon = mo_icon.disk5
                page.texts[3].str = "DISK FULL  "
            end

            if (diskinfo.stat == 6) then
                -- page.icons[1].icon = mo_icon.disk6
                page.texts[3].str = "DISK INIT "
            end

            if (diskinfo.disksize) then
                page.texts[2].str = diskinfo.disksize
            end
        end
    end,
    texts = {
        {
            x = 38,
            y = 1,
            str = "SATA1",
            size = 8
        },
        {
            x = 38,
            y = 1,
            str = "",
            size = 8
        },
        {
            x = 32,
            y = 3,
            str = "",
            size = 16
        }
    },
    icons = {
        {
            x = 5,
            y = 3,
            icon = mo_icon.point
        }
    }
}

_M.HARDDISK2 = {
    bg = mo_bg.diskinfo,  
    getinfo =  function (page)
        local diskinfo = mo_info.getSATA(2)
        if (diskinfo) then
            if (diskinfo.stat == 0) then
                -- page.icons[1].icon = mo_icon.disk0
                page.texts[3].str = "NO DISK   "
            end

            if (diskinfo.stat == 1) then
                -- page.icons[1].icon = mo_icon.disk1
                page.texts[3].str = "NO RECORDING"
            end

            if (diskinfo.stat == 2) then
                -- page.icons[1].icon = mo_icon.disk2
                page.texts[3].str = "NOT MOUNT "
            end

            if (diskinfo.stat == 3) then
                -- page.icons[1].icon = mo_icon.disk3
                page.texts[3].str = "RECORDING "
            end


            if (diskinfo.stat == 4) then
                -- page.icons[1].icon = mo_icon.disk4
                page.texts[3].str = "ERROR    "
            end


            if (diskinfo.stat == 5) then
                -- page.icons[1].icon = mo_icon.disk5
                page.texts[3].str = "DISK FULL  "
            end

            if (diskinfo.stat == 6) then
                -- page.icons[1].icon = mo_icon.disk6
                page.texts[3].str = "DISK INIT "
            end

            if (diskinfo.disksize) then
                page.texts[2].str = diskinfo.disksize
            end
        end
    end,
    texts = {
        {
            x = 38,
            y = 1,
            str = "SATA2",
            size = 8
        },
        {
            x = 38,
            y = 1,
            str = "",
            size = 8
        },
        {
            x = 32,
            y = 3,
            str = "",
            size = 16
        }
    },
    icons = {
        {
            x = 5,
            y = 3,
            icon = mo_icon.point
        }
    }
}

_M.RECSTAT = {
    bg = mo_bg.info,
    getinfo =  function (page)        
        local recordinfo = mo_info.GetRecordStatus()
        if (recordinfo.status) then
            -- page.icons[1].icon = mo_icon.recording
            -- page.icons[1].icon = mo_icon.record_stat
            page.texts[2].str = "RECORDING"
            page.icons[2].icon = mo_icon.stop
        else
            -- page.icons[1].icon = mo_icon.norecord
            -- page.icons[1].icon = mo_icon.record_stat
            page.texts[2].str = "RECORD STOP"
            page.icons[2].icon = mo_icon.start
        end

        if (recordinfo.disk) then
            if recordinfo.disk == 0 then
                page.texts[1].str = "NO DISK"
            else
                page.texts[1].str = "DISK：SATA".. tostring(recordinfo.disk)
            end
        else
            page.texts[1].str = ""
        end
    end,
    texts={
        {
            x = 5,
            y = 4,
            str = "DISK：SATA1",
            size = 16
        },
        {
            x = 38,
            y = 1,
            str = "",
            size = 16
        },
    },
    icons={
        {
            x = 0,
            y = 1,
            icon = mo_icon.record_stat
        },
        {
            x = 75,
            y = 6,
            icon = mo_icon.start
        },
    }
}

_M.DISKCONTROL = {
    bg= mo_bg.diskop,                        
    f1 = { -- 磁盘初始化确认
        oppage = true,
        bg = mo_bg.pub,
        icons={
            {
                x = 5,
                y = 2,
                icon = mo_icon.init
            },
            {
                x = 5,
                y = 2,
                icon = mo_icon.init
            }
        },
        texts = {
            {
                x = 32,
                y = 2,
                str = "INIT DISK?  ",
                size = 16
            },
        },       
        f1 = function() 
        end,
        f2 = function()
        end,
        f3 = {
            oppage = true,
            name = "diskinit",
            bg = mo_bg.info,
            getinfo =  function (page)       
                -- print("diskinit "..page.diskid)
                page.texts[1].str = "Init faild"
            end,
            texts = {
                {
                    x = 32,
                    y = 2,
                    str = "",
                    size = 16
                },
            },
            icons={
                {
                    x = 5,
                    y = 2,
                    icon = mo_icon.init
                }
            },
            f1 = function() 
            end,
            f2 = function()
            end,
            f3 = function()
            end
        }
    },    
    f2={ -- 磁盘弹出
        oppage = true,
        bg = mo_bg.pub,
        icons={
            {
                x = 5,
                y = 2,
                icon = mo_icon.diskremove
            }
        },
        texts = {
            {
                x = 32,
                y = 2,
                str = "REJECT DISK",
                size = 16
            },
        },    
        f1 = function() 
        end,
        f2 = function()
        end,
        f3 = {
            oppage = true,
            name = "removepage",
            bg = mo_bg.info,
            getinfo =  function (page)        
                _dbg.Info("getinfo", "disk remove")
            end,
            texts = {
                {
                    x = 32,
                    y = 2,
                    str = "",
                    size = 16
                },
            },
            icons={
                {
                    x = 5,
                    y = 2,
                    icon = mo_icon.diskremove
                }
            },
            f1 = function() 
            end,
            f2 = function()
            end,
            f3 = function()
            end
        }
    },
    f3 = {  --设置录像
        oppage = true,
        bg = mo_bg.pub,
        icons={
            {
                x = 5,
                y = 2,
                icon = mo_icon.diskrecord
            }
        },
        texts = {
            {
                x = 32,
                y = 2,
                str = "SET RECORD  ",
                size = 16
            },
        },  
        f1 = function() 
        end,
        f2 = function()
        end,
        f3 = {
            oppage = true,
            name = "setrecord",
            bg = mo_bg.info,
            getinfo =  function (page)        
                _dbg.Info("diskinfo", "setrecord")
            end,
            texts = {
                {
                    x = 32,
                    y = 2,
                    str = "",
                    size = 16
                },
            },
            icons={
                {
                    x = 5,
                    y = 2,
                    icon = mo_icon.diskrecord
                }
            },
            f1 = function() 
            end,
            f2 = function()
            end,
            f3 = function()
            end
        }
    },
    getinfo =  function (page)    
        --dosth
    end,
    texts = {
        {
            x = 5,
            y = 4,
            str = "SATA1",
            size = 8
        },
        {
            x = 35,
            y = 2,
            str = "DISK MANAGE",
            size = 16
        },
    }
}

_M.DISKCONTROL1=pt.deepcopy (_M.DISKCONTROL)
_M.DISKCONTROL1.texts[1].str = "SATA1"
_M.DISKCONTROL1.f1.f3.getinfo =  function (page)       
    print("diskinit 1")
    if (mo_info.initDisk(1)) then
        -- page.icons[2].icon = mo_icon.initing
        page.texts[1].str = "Initing..."
    else
        -- page.icons[2].icon = mo_icon.initerr
        page.texts[1].str = "Init Failed"
    end
end

_M.DISKCONTROL1.f2.f3.getinfo =  function (page)       
    print("RemoveDisk 1")
    if (mo_info.RemoveDisk(1)) then
        -- page.icons[2].icon = mo_icon.diskremoveok
        page.texts[1].str = "Reject OK"
    else
        -- page.icons[2].icon = mo_icon.diskremoveer
        page.texts[1].str = "Reject Failed"
    end
end

_M.DISKCONTROL1.f3.f3.getinfo =  function (page)       
    print("Set_Record_disk 1")
    if (mo_info.Set_Record_disk(1)) then
        -- page.icons[2].icon = mo_icon.diskrecordok
        page.texts[1].str = "SET OK"
    else
        -- page.icons[2].icon = mo_icon.diskrecorderr
        page.texts[1].str = "SET Failed"
    end
end


_M.DISKCONTROL2=pt.deepcopy (_M.DISKCONTROL)
_M.DISKCONTROL2.texts[1].str = "SATA2"
_M.DISKCONTROL2.f1.f3.getinfo =  function (page)       
    print("diskinit 2")
    if (mo_info.initDisk(2)) then
        -- page.icons[2].icon = mo_icon.initing
        page.texts[1].str = "Initing..."
    else
        -- page.icons[2].icon = mo_icon.initerr
        page.texts[1].str = "Init failed"
    end
end

_M.DISKCONTROL2.f2.f3.getinfo =  function (page)       
    print("RemoveDisk 2")
    if (mo_info.RemoveDisk(2)) then
        -- page.icons[2].icon = mo_icon.diskremoveok
        page.texts[1].str = "Reject OK"
    else
        -- page.icons[2].icon = mo_icon.diskremoveerr
        page.texts[1].str = "Reject Failed"
    end
end

_M.DISKCONTROL2.f3.f3.getinfo =  function (page)       
    print("Set_Record_disk 2")
    if (mo_info.Set_Record_disk(2)) then
        -- page.icons[2].icon = mo_icon.diskrecordok
        page.texts[1].str = "SET OK"
    else
        -- page.icons[2].icon = mo_icon.diskrecorderr
        page.texts[1].str = "SET Failed"
    end
end


_M.RECCONTROL = {
    bg = mo_bg.info,
    getinfo =  function (page)        
        local recordinfo = mo_info.GetRecordStatus()
        if (recordinfo.status) then
            -- page.icons[1].icon = mo_icon.stoprec
            page.texts[1].str = "STOPRECORD"
            page.icons[2].icon = mo_icon.stop
            page.f3.getinfo =  function (page)        
                _dbg.Info("diskinfo", "StopRecord")
                if mo_info.StopRecord() then
                    -- page.icons[1].icon = mo_icon.stoprecok
                    page.texts[1].str = "Stop OK"
                else
                    -- page.icons[1].icon = mo_icon.recerr
                    page.texts[1].str = "Stop Failed"
                end
            end
        else
            -- page.icons[1].icon = mo_icon.startrec
            page.texts[1].str = "StartRECORD"
            page.icons[2].icon = mo_icon.start
            page.f3.getinfo =  function (page)        
                _dbg.Info("diskinfo", "StartRecord")                
                if mo_info.StartRecord() then
                    -- page.icons[1].icon = mo_icon.startrecok
                    page.texts[1].str = "Start OK"
                else
                    -- page.icons[1].icon = mo_icon.recerr
                    page.texts[1].str = "Failed"
                end
            end
        end
    end,
    texts={
        {
            x = 35,
            y = 2,
            str = "",
            size = 16
        },
    },
    icons={
        {
            x = 5,
            y = 2,
            icon = mo_icon.record_stat
        },
        {
            x = 75,
            y = 6,
            icon = mo_icon.start
        }
    },
    f1 = function()             
    end,
    f2 = function()
    end,
    f3 = {
        oppage = true,
        name = "infopage",
        bg = mo_bg.info,
        getinfo =  function (page)        
            _dbg.Info("diskinfo", "control rec")
        end,
        texts={
            {
                x = 35,
                y = 2,
                str = "",
                size = 16
            },
        },
        icons={
            {
                x = 5,
                y = 2,
                icon = mo_icon.record_stat
            }
        },
        f1 = function() 
        end,
        f2 = function()
        end,
        f3 = function()
        end
    }
}

_M.RESTORECONTROL = {
    bg = mo_bg.info,
    texts={
        {
            x = 40,
            y = 2,
            str = "RESET?",
            size = 16
        }
    },
    icons={
        {
            x = 0,
            y = 1,
            icon = mo_icon.network
        },
        {
            x = 75,
            y = 6,
            icon = mo_icon.reset
        }
    },
    f1 = function()             
    end,
    f2 = function()
    end,
    f3 = {
        oppage = true,
        name = "infopage",
        bg = mo_bg.info,
        getinfo =  function (page)
            _dbg.Info("OT", "netword restore")
            local r,info = mo_info.RestoreIP2()
            if info then
                page.texts[1].str = info
            end
        end,
        texts={
            {
                x = 40,
                y = 2,
                str = "",
                size = 16
            }
        },
        icons={
            {
            x = 0,
            y = 1,
            icon = mo_icon.network
            }
        },
        f1 = function() 
        end,
        f2 = function()
        end,
        f3 = function()
        end
    }
}

_M.PUBSTAT = {
    bg = mo_bg.pub,
    getinfo =  function (page)
        local enable_count, count = mo_info.GetPub()        
        if enable_count ~= 0 or count ~= 0 then
            page.texts[2].str = tostring(enable_count).."/"..tostring(count)
        end
    end,
    texts={
        {
            x = 45,
            y = 2,
            str = "LIVE PUB",
            size = 16
        },
        {
            x = 58,
            y = 5,
            str = "",
            size = 8
        },        
    },
    icons={
        {
            x = 5,
            y = 1,
            icon = mo_icon.tuiliu
        }
    }
}

_M.PUBCONTROL = {
    bg = mo_bg.info,
    getinfo =  function (page)     
    end,
    texts={
        {
            x = 35,
            y = 2,
            str = "START/STOP",
            size = 16
        }
    },
    icons={
        {
            x = 5,
            y = 1,
            icon = mo_icon.tuiliu
        },
        {
            x = 40,
            y = 6,
            icon = mo_icon.start
        },
        {
            x = 75,
            y = 6,
            icon = mo_icon.stop
        }
    },
    f1 = function()             
    end,
    f2 = {
        oppage = true,
        name = "infopage",
        bg = mo_bg.info,
        getinfo =  function (page)        
            if mo_info.SetPub( true ) then
                page.texts[1].str = "Started"
            else
                page.texts[1].str = "Start Failed"
            end
        end,
        texts={
            {
                x = 35,
                y = 2,
                str = "",
                size = 16
            }
        },
        icons={
            {
                x = 5,
                y = 1,
                icon = mo_icon.tuiliu
            }
        },
        f1 = function() 
        end,
        f2 = function()
        end,
        f3 = function()
        end
    },
    f3 = {
        oppage = true,
        name = "infopage",
        bg = mo_bg.info,
        getinfo =  function (page)        
            if mo_info.SetPub( false ) then
                page.texts[1].str = "Stoped"
            else
                page.texts[1].str = "Stop Failed"
            end
        end,
        texts={
            {
                x = 35,
                y = 2,
                str = "",
                size = 16
            }
        },
        icons={
            {
                x = 5,
                y = 1,
                icon = mo_icon.tuiliu
            }
        },
        f1 = function() 
        end,
        f2 = function()
        end,
        f3 = function()
        end
    }
}

_M.LIST = {
    {
        name = "LOGO",
        pagedata = _M.LOGO, 
        subpages = {
            {
                name = "ICONPAGE",
                type = "iconpage",
                icons = {
                    {
                        name = "视频",
                        data ={                           
                            -- 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xC0,0xE0,0x60,0x30,0x30,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0x30,0x30,0x60,0xE0,0xC0,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                            -- 0x00,0x00,0x00,0x00,0x00,0xFC,0xFF,0x03,0x01,0xFC,0xFE,0x07,0x03,0xF1,0xF9,0x19,0x19,0xF9,0xF1,0x03,0x07,0xFE,0xFC,0x01,0x07,0xFF,0xFC,0x00,0x00,0x00,0x00,0x00,
                            -- 0x00,0x00,0x00,0x00,0x00,0x0F,0x1F,0x38,0x70,0xE7,0xCF,0x9C,0x18,0xFD,0xFF,0x0F,0x0F,0xFF,0xFD,0x18,0x8C,0xCF,0xE7,0x70,0x38,0x1F,0x0F,0x00,0x00,0x00,0x00,0x00,
                            -- 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x0F,0x1C,0x1C,0x0F,0x07,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                            0x00,0x00,0x00,0xF0,0xF0,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0xF0,0xF0,0x00,0x00,0x00,
                            0x00,0x00,0x00,0xFF,0xFF,0x00,0x00,0xF0,0xF8,0x0C,0xE6,0xF2,0x18,0x08,0x80,0xC0,0xC0,0x80,0x08,0x18,0xF2,0xE6,0x0C,0xF8,0xF0,0x00,0x00,0xFF,0xFF,0x00,0x00,0x00,
                            0x00,0x00,0x00,0xFF,0xFF,0x00,0x00,0x0F,0x1F,0x30,0x67,0x4F,0x18,0x10,0x01,0x03,0x03,0x01,0x10,0x18,0x4F,0x67,0x30,0x1F,0x0F,0x00,0x00,0xFF,0xFF,0x00,0x00,0x00,
                            0x00,0x00,0x00,0x0F,0x0F,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0F,0x0F,0x00,0x00,0x00
                        },
                        title = "VIDEOIN",
                        subpages = {
                            {
                                name = "VIDEOIN-1",
                                pagedata = _M.VIDEOIN1
                            },
                            {
                                name = "VIDEOIN-2",
                                pagedata = _M.VIDEOIN2
                            }
                        }
                    },
                    {
                        name = "网络",
                        data={
                            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF0,0xF0,0x30,0x30,0x30,0x30,0x30,0x30,0xF0,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x80,0x80,0x9F,0x9F,0x98,0x98,0xF8,0xF8,0x98,0x98,0x9F,0x9F,0x80,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                            0x00,0x00,0x00,0x00,0xF8,0xF8,0x18,0x18,0x1F,0x1F,0x19,0x19,0xF9,0xF9,0x01,0x01,0x01,0x01,0xF9,0xF9,0x19,0x19,0x1F,0x1F,0x18,0x18,0xF8,0xF8,0x00,0x00,0x00,0x00,
                            0x00,0x00,0x00,0x00,0x0F,0x0F,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0F,0x0F,0x00,0x00,0x00,0x00,0x0F,0x0F,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0F,0x0F,0x00,0x00,0x00,0x00,
                        },
                        title = "NETWORK",
                        subpages = {
                            {
                                name = "NETWORK",
                                pagedata = _M.NETWORK,
                                interaction = {
                                    name = "RESTORECONTROL",
                                    pagedata = _M.RESTORECONTROL
                                }
                            }
                        }
                    },
                    {
                        name = "编码",
                        data = {
                            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xC0,0xC0,0xC0,0xC0,0xC0,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                            0x00,0x00,0x00,0x00,0xC0,0xE0,0xE0,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x7F,0x7F,0x03,0x01,0x01,0x01,0x03,0x7F,0x7F,0x60,0x60,0xE0,0xE0,0xC0,0x00,0x00,0x00,0x00,
                            0x00,0x00,0x00,0x00,0xFF,0xFF,0x80,0x00,0x1C,0x1C,0x1C,0x00,0x1C,0x1C,0x1C,0x00,0x1C,0x1C,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xFF,0xFF,0x00,0x00,0x00,0x00,
                            0x00,0x00,0x00,0x00,0x01,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x01,0x00,0x00,0x00,0x00
                        },
                        title = "ENCODER",
                        subpages = {
                            {
                                name = "ENCODER-1",
                                pagedata = _M.ENCODER1
                            },
                            {
                                name = "ENCODR-2",
                                pagedata = _M.ENCODER2                        
                            },
                            {
                                name = "ENCODER-3",
                                pagedata = _M.ENCODER3              
                            },
                            {
                                name = "ENCODER-4",
                                pagedata = _M.ENCODER4
                            },
                            {
                                name = "ENCODER-5",
                                pagedata = _M.ENCODER5                 
                            },
                            {
                                name = "ENCODER-6",
                                pagedata = _M.ENCODER6                                              
                            }
                        }
                    },
                    { 
                        name = "平台",
                        data ={
                            0x00,0x00,0x00,0x00,0xF0,0xF0,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0x70,0xF0,0xF0,0x00,0x00,0x00,0x00,
                            0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x8C,0x8C,0x8C,0x8C,0x8C,0x8C,0x8C,0x8C,0x8C,0x8C,0x8C,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,
                            0x00,0x00,0x00,0x00,0x7F,0x7F,0x60,0x60,0x60,0x60,0x60,0x61,0x61,0x61,0x61,0xE1,0xE1,0x61,0x61,0x61,0x61,0x61,0x60,0x60,0x60,0x60,0x7F,0x7F,0x00,0x00,0x00,0x00,
                            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0x1F,0x1F,0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                        },
                        title = "PLATFORM",
                        subpages = {
                            {
                                name = "PLATFORM",
                                pagedata =  _M.PLATFORM
                            }
                        }
                    },
                    {
                        name = "磁盘",
                        data = {
                            0x00,0x00,0x00,0x00,0x00,0xE0,0xF0,0xF0,0x70,0x30,0x30,0xF0,0xF0,0xF0,0xB0,0xB0,0xB0,0xB0,0xF0,0xF0,0xF0,0xF0,0xE0,0xC0,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                            0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0xE0,0xF1,0x71,0x39,0x39,0x39,0x39,0x71,0xF1,0xE0,0x00,0x01,0x03,0x07,0xFF,0xFE,0x00,0x00,0x00,0x00,0x00,
                            0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0x07,0x8F,0x8E,0x9C,0x9C,0x9C,0x9C,0x8E,0x8F,0x07,0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,
                            0x00,0x00,0x00,0x00,0x00,0x07,0x0F,0x0F,0x0E,0x0C,0x0C,0x0F,0x0F,0x0F,0x0D,0x0D,0x0D,0x0D,0x0F,0x0F,0x0F,0x0C,0x0C,0x0E,0x0F,0x0F,0x07,0x00,0x00,0x00,0x00,0x00
                        },
                        title = "HARDDISK",
                        subpages = {
                            {
                                name = "HARDDISK-1",                
                                pagedata = _M.HARDDISK1,
                                interaction = {
                                    name = "disk control",
                                    pagedata = _M.DISKCONTROL1
                                }  
                            },
                            {
                                name = "HARDDISK-2",                
                                pagedata = _M.HARDDISK2,
                                interaction = {
                                    name = "disk control",
                                    pagedata = _M.DISKCONTROL2
                                }                
                            },
                        }
                    },
                    {
                        name = "录像",
                        data = {
                            0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0xE0,0x70,0x30,0x30,0x30,0x70,0xE0,0xC0,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                            0x00,0x00,0x00,0x00,0xE0,0xF0,0x37,0x3F,0x3E,0x3C,0x3C,0x3C,0x3E,0x37,0x37,0x3F,0x39,0x39,0x3F,0x37,0x70,0xF0,0xE0,0x00,0x00,0x80,0xC0,0xC0,0x00,0x00,0x00,0x00,
                            0x00,0x00,0x00,0x00,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xEE,0xC7,0x83,0xFF,0xFF,0x00,0x00,0x00,0x00,
                            0x00,0x00,0x00,0x00,0x07,0x0F,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0E,0x0F,0x07,0x00,0x01,0x03,0x07,0x07,0x00,0x00,0x00,0x00,
                        },
                        title = "RECORDER",
                        subpages = {
                            {
                                name = "RECORDSTAT",
                                pagedata = _M.RECSTAT,
                                interaction = {
                                    name = "RECORDCONTROL",
                                    pagedata = _M.RECCONTROL
                                }
                            }
                        }
                    },
                    {
                        name = "推流",
                        data={
                            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xC0,0xE0,0x60,0x30,0x30,0xB0,0xB0,0xB0,0xB0,0xB0,0xB0,0x30,0x30,0x60,0xE0,0xC0,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                            0x00,0x00,0x00,0x00,0x00,0xFC,0xFF,0x03,0x01,0xFC,0xFE,0x07,0x03,0xF1,0xF9,0x19,0x19,0xF9,0xF1,0x03,0x07,0xFE,0xFC,0x01,0x07,0xFF,0xFC,0x00,0x00,0x00,0x00,0x00,
                            0x00,0x00,0x00,0x00,0x00,0x0F,0x1F,0x38,0x70,0xE7,0xCF,0x9C,0x18,0xFD,0xFF,0x0F,0x0F,0xFF,0xFD,0x18,0x8C,0xCF,0xE7,0x70,0x38,0x1F,0x0F,0x00,0x00,0x00,0x00,0x00,
                            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x0F,0x1C,0x1C,0x0F,0x07,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
                        },
                        title = "STREAMER",
                        subpages = {
                            {
                                name = "PUBSTART",
                                pagedata = _M.PUBSTAT,
                                interaction = {
                                    name = "PUBCONTROL",
                                    pagedata = _M.PUBCONTROL
                                }
                            }
                        }
                    },     
                }
            }            
        }
    }    
}

-- _M.Index = 0
-- _M.Level = 0


_M.RECSTAT_LOGO = {
    bg = mo_bg.blank,
    getinfo =  function (page)        
        local recordinfo = mo_info.GetRecordStatus()
        if (recordinfo.status) then
            page.icons[1].icon = mo_icon.recording
            --page.icons[2].icon = mo_icon.stop
        else
            page.icons[1].icon = mo_icon.norecord
            --page.icons[2].icon = mo_icon.start
        end

        if (recordinfo.disk) then
            page.texts[1].str = "DISK：SATA".. tostring(recordinfo.disk)
        else
            page.texts[1].str = ""
        end

        local rectime = mo_info.GetRecordTimeFuture()
        if rectime then
            page.texts[2].str = "remain:".. rectime
        end

    end,
    texts={
        {
            x = 5,
            y = 4,
            str = "DISK：SATA1",
            size = 16
        },
        {
            x = 5,
            y = 6,
            str = "Remain:unknown",
            size = 16
        }
    },
    icons={
        {
            x = 0,
            y = 1,
            icon = mo_icon.norecord
        }
    }
}

return _M

