local coaf = require "coaf.core"
local _dbg = require "coaf.debug"
local hiperiphery = require "hiperiphery"
local HIMM = hiperiphery.HIMM
require "beep"

local _M = {
    TK_Address = {
        { {0x120f0134,0x0}, {0x121c0400,0x0}, 0x121c0008 },    --TK4
        { {0x120f0130,0x0}, {0x121c0400,0x0}, 0x121c0004 },   --TK3
        { {0x120f012c,0x1}, {0x121b0400,0x0}, 0x121b0200 },   --TK2
        { {0x120f0128,0x1}, {0x121b0400,0x0}, 0x121b0100 }   --TK1
    },
    old_ttl = {},
    old_ret = {},
    flag_beep = false
}

function _M.GetTTL()
    local val = {}
    for i,add in ipairs(_M.TK_Address) do
        HIMM.write( add[1][1], add[1][2] )
        HIMM.write( add[2][1], add[2][2] )
        val[i] = HIMM.read( add[3] )
        if (val[i] == 0x0) then 
            val[i] = 0  --按下 低电平
        else
            val[i] = 1  
        end
	end
    return val
end

-- local ret = _M.GetTTL()
-- for i,ttl in ipairs(ret) do
--     _dbg.Info("GPIO", i .. " " ..ttl )
-- end

-- _M.old_ttl = _M.GetTTL()

function _M.DetectPress()    
    local ret = { false, false, false, false }
    local ttls = _M.GetTTL()
    for i,ttl in ipairs(ttls) do
        
        -- 下降沿触发
        -- if (ttl == 0x0) and (0x00 ~= _M.old_ttl[i]) then     --只按下时触发
        --     -- _dbg.Info("GPIO", "TK" .. i .. " press !")
        --     ret[i] = true
        -- else
        --     ret[i] = false
        -- end

        -- 滤波实现
        newttl = _M.old_ttl[i]*0.8 + ttl*0.2                   
        if (newttl < 0.2) and ( _M.old_ttl[i] >= 0.2) then
        -- if (newttl <= 0.2) then
            -- _dbg.Info("GPIO", "TK " .. i .. " press !")
            ret[i] = true
        else
            ret[i] = false
        end     
        _M.old_ttl[i] = newttl
    end
    return ret
end

function _M.Beep()
    HIMM.write( 0x120f018c, 0x1 )
    HIMM.write( 0x12200400, 0x10 )
    BEEP.Beep.beep()
end


function _M.init()
    _M.old_ttl = _M.GetTTL()
end

-- _M.DetectPress()

return _M