local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/osd.conf"
}

----------------------------

local osd_template = DC.OBJ({
	output = DC.SET(
		DC.OBJ({
			enabled = DC.INT(1),
			norotate = DC.INT(1),
			screen_w = DC.INT(40),
			screen_h = DC.INT(22),
			shiftX = DC.NUM(0.5),
			shiftY = DC.NUM(0.5),
			
			items = DC.SET(
				DC.OBJ({
					osd_type = DC.STR("none"),
					text = DC.STR(""),
					dynamic_show = DC.INT(1) : __nosave(true) : __set( function(cfg,key,val)
						cfg.__proto.changes[key] = 'set' --Always be changed if set.
						return true, val
					end),
					position = DC.STR("left-top"),
					x = DC.INT(0),
					y = DC.INT(0),
					font = DC.STR("song"),
					size = DC.INT(2),--0 small, 1 middle, 2 large, otherwise specified size
					outline = DC.INT(1),
					bold = DC.INT(0),
					italic = DC.INT(0),
					image_id = DC.STR("default"),
					color = DC.INT(1),
					outlineColor = DC.INT(0)
				})
			) --Of items array
		}) --Of output object
	) --Of output array
}) : __changed( function(conf,name,action)
	conf:TAB_SAVE()
	local osd = require "mod_ImgOSD"
	osd.UpdateTextOSD()
end)

-------------------------------------------

local failDefault = {
	output = {
		[1] = {
			enabled = 1,
			items = {[0]={}, [1]={}, [2]={}, [3]={}}
		},
		[2] = {
			enabled = 1,
			items = {[0]={}, [1]={}, [2]={}, [3]={}}
		}
	}
}

function _M.Load()
	local conf = CONF.Create({}, osd_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
	local _, r = conf:TAB_LOAD()
	if not r then --Try load a fail-default configure
		conf:TAB_BIND(failDefault)
	end

	conf:TAB_RESET_CHANGE()
	return conf
end

-----------------------------------------------------------

return _M

