local CFG = require "supertable.core"
local DC = require "supertable.declare"

local _M = {
	config_file = "/data/configs/pics.conf"
}


local general_set_decl = DC.SET( DC.OBJ {
        id = DC.INT(),
        size_h = DC.INT(),
        size_w = DC.INT(),
        url = DC.STR(),
        type = DC.STR(),
        name = DC.STR("")        
} ) : __changed( function(conf)
        conf:TAB_SAVE()
end )



function _M.Load(file)
        local gen_set = CFG.Create( {}, general_set_decl )
        gen_set:TAB_STORAGE( "file", { file = _M.config_file } )
        gen_set:TAB_LOAD()
        gen_set:TAB_RESET_CHANGE()
        return gen_set
end

return _M
