#!/usr/bin/env lua
local coaf = require "coaf.core"
local _dbg = require "coaf.debug"
local thread = require "coaf.thread"
local service = require "coaf.service"
local roll = require "coaf.log.rollfile"
-- Change current dir to app location
coaf.ChDir(coaf.GetAppDir(arg))

local rtc = require "rtc"

-- First, initialize the log file.
os.execute( "/bin/mkdir -p /var/log" )
local logF = roll.Create("/var/log/rtc.log")
if not logF or not logF:init() then
	_dbg.Error("RTC", "Fail to open log file: /var/log/rtc.log, so the log messages should be output to console.")
else
	_dbg.AddLogger("logfile", logF, nil, nil)
end
----------------------------------

coaf.Init( "rtc" )
-- Initialize service.
service.InitSocket()
local rtc_service
----------------------------------

local function Main(args)
	coaf.CreatePIDFile( "/var/run/rtc.pid" )	
	rtc.Init()	
	rtc.Load()
	-- rtc.Store()
	rtc_service = service.New( "rtc", "unix:/var/run/rtc.sock" )
	if rtc_service then
		rtc_service:CreateCoServerProxy()
		rtc_service:ExposeObject("/", rtc )
	else
		_dbg.Error( "RTC", "Fail to create CoService for rtc" )
	end
end

coaf.Start(Main,arg)

rtc.Store()

rtc.Destroy()

_dbg.Print( "RTC", "RTC service is terminated." )

