local coaf = require "coaf.core"
local _dbg = require "coaf.debug"
local client = require "coaf.client"

local LED = require "ui_leds"
local SW = require "ui_switchs"

local _M = {
	lastAlarmTime = {}
}

local testing = false

local function restoreCallback()
	if not testing then
		local cli = client.New( "systemctrl" )
		if cli then
			local proxy = cli:CreateProxy( "/", true )	--exclusive.
			if proxy then
				proxy.RestoreFactory()
				proxy:Destroy()
			end
			cli:Destroy()
		end
	end
end


function _M.Init()
	LED.Init()
	SW.Init()

	SW.CreateSW( "restore", { --KEY_RESET  GPIO0_0 YIDUO 3536
		muxreg = 0x120f0148,
		muxval = 0,
		pingroup = 0x12150000, --0x12150400
		pin = 0,
		holdTimes = 24,
		callback = restoreCallback
	})

	LED.CreateLight( "run", { --GPIO14_7
		muxreg = 0x120f0098,
		muxval = 1,
		pingroup = 0x12230000,
		pin = 7,
		pol = 0
	})
end

function _M.DetectAmbaError()
    LED.Force( "run", LED.BLINK_VERYFAST )
end

function _M.RunningStatus()
    LED.Force( "run", LED.BLINK )
end

return _M

