local _M = {
	CACHED_SERIAL_NO = nil
}

function _M.GetSerialNo()
	if not _M.CACHED_SERIAL_NO then
		local f = io.open( "/etc/SERIAL_NO", "r" )
		if f then
			_M.CACHED_SERIAL_NO = f:read("*l")
			f:close()
		end
	end
	return _M.CACHED_SERIAL_NO or "000000000"
end

function _M.CreateSerialNo( serialNo, sign )
	if serialNo then
		_M.CACHED_SERIAL_NO = serialNo
		local f = io.open( "/etc/SERIAL_NO", "w" )
		if f then
			f:write( serialNo )
			f:write( "\n" )
			f:close()
		end
	end

	if sign then
		local f = io.open( "/etc/LICENSE", "w" )
		if f then
			f:write( sign )
			f:close()
		end
	end

	os.execute( "/bin/sync" )
	return true
end

return _M

